


#include <windows.h>
#include <string>
#include <tchar.h>
#include <process.h>
#include <stb_image.c>


using namespace std;
//-//
// those lines include other files and name spaces which enable a variety of functions


#define DLLEXPORT extern "C" __declspec(dllexport) // an important line which simplifies your work when writting a DLL for GM
												   // whenever a fucntion shall be acessible from GM, write DLLEXPORT before it from now on

//<>//
    WNDCLASSEX wCl;
	volatile LPCTSTR szWindowClass;

	volatile byte nextInstance;
	volatile byte currentStartedSpr;

	volatile HWND GMwindow;

	const byte arrayMax = 30; // number of available animations at the same time. The higher this number the mroe space will be reserved...

	POINT mouseXY;
	volatile bool filledArr[arrayMax];
	volatile HBITMAP hBitArr[arrayMax];
	int wholeWidthArr[arrayMax];
	SIZE sizeArr[arrayMax];
	POINT positionArr[arrayMax];
	volatile int timeArr[arrayMax];
	volatile bool windowedArr[arrayMax];
	volatile bool attachedArr[arrayMax];

	volatile int frameArr[arrayMax];
	volatile bool updateArr[arrayMax];

	volatile byte alphaArr[arrayMax];
	volatile byte blendAlphaArr[arrayMax];
	volatile int blendSubArr[arrayMax];

	volatile byte runningArr[arrayMax];

	volatile bool GMvisible;
	volatile bool onfront;

	volatile bool killAll;
	
	volatile int windowX;
	volatile int windowY;


//<>//


BOOL __stdcall DllMain(HANDLE hinstDLL, DWORD dwReason, LPVOID lpvReserved)
{

        switch (dwReason)
        {
        case DLL_PROCESS_ATTACH: // start
			{

//	wCl = {0};

    szWindowClass = _T("TransparentClass");

    wCl.cbSize = sizeof(WNDCLASSEX);
    wCl.lpfnWndProc    = DefWindowProc;
    wCl.lpszClassName  = szWindowClass;


    RegisterClassEx(&wCl);


	for(byte i = 0; i < arrayMax; i++)
	filledArr[i] = false;

	onfront = 1;

	nextInstance = 0;
	killAll = false;


			} break;
        case DLL_PROCESS_DETACH: // end
			{


	for(byte i = 0; i < arrayMax; i++)
	{
	if (filledArr[i]) DeleteObject(hBitArr[i]);
	updateArr[i] = false;
	}

	killAll = true;

	Sleep(50);


			} break;
        }
        return TRUE; // return whetehr initialisation has been sucessfull
}




void showError(LPCSTR capt)
{

LPTSTR Error = 0;
FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
					NULL,
                    GetLastError(),
                    0,
                    (LPTSTR)&Error,
                    0,
                    NULL);

MessageBox( 0, Error,capt, MB_OK );
}


void updateWindows(void*);

DLLEXPORT double Init(double window, double winx, double winy) { 

	GMwindow = (HWND)(INT)window;

	windowX = (int)winx;
	windowY = (int)winy;

	_beginthread( updateWindows, 0, 0);
	Sleep(10);


	return(1);

}



void updateWindows(void*) // this is the prozess which is called in the background in another Thread
{

	RECT rc;

	int wb, wh;

	GetWindowRect(GMwindow,&rc);
	wb = windowX-rc.left;
	wh = windowY-rc.top;

	
	while(!killAll)
	{

	GetCursorPos(&mouseXY);

	onfront = (GetForegroundWindow() == GMwindow);
	GMvisible = (IsWindowVisible(GMwindow));

	GetWindowRect(GMwindow,&rc);


	if ((!(windowX == rc.left)) || (!(windowY == rc.top)))
	{

	windowX = rc.left+wb;
	windowY = rc.top+wh;

	for(byte i = 0; i < arrayMax; i++)
	{
		if (runningArr[i])
		{
		if (windowedArr[i])
		updateArr[i] = true;
		}
	}
	}



	Sleep(14);

	}
}


DLLEXPORT double Load(char* file, double frameWidth, double col) { 


    unsigned char *res_data, *image;
    DWORD res_size;
    int wholeWidth, frameHeight, components;
    BITMAPV5HEADER bmh;
    FILE* f = _tfopen((const char*)file, "rb");

    if (!f)
        showError("Opening the file failed!");

    fseek(f, 0, SEEK_END);
    res_size = ftell(f);
    rewind(f);

    res_data = new unsigned char[res_size];
    fread(res_data, sizeof(unsigned char), res_size, f);
    fclose(f);

    image = stbi_load_from_memory(res_data, res_size, &wholeWidth, &frameHeight, &components, 0);


	int col_r = ((int)col & 255)/255;
	int col_g = (((int)col >> 8) & 255)/255;
	int col_b = (((int)col >> 16) & 255)/255;

//	MessageBox( 0, (LPCSTR)col_r ,"", MB_OK );


	LPBYTE bits = (LPBYTE)image;
	int size = wholeWidth * frameHeight;
	for (int pixel = 0, nn = 0; pixel != size; ++pixel)
	{
		bits[2] = col_b*bits[2];
		bits[1] = col_g*bits[1];
		bits[0] = col_r*bits[0];
	

		nn = bits[2];

		bits[2] = bits[0] * bits[3] / 255;
		bits[1] = bits[1] * bits[3] / 255;
		bits[0] = nn * bits[3] / 255;

		bits += 4;
	}



	ZeroMemory(&bmh, sizeof(BITMAPV5HEADER));
	bmh.bV5Size = sizeof(BITMAPV5HEADER);
	bmh.bV5Width = wholeWidth;
	bmh.bV5Height = -frameHeight;
	bmh.bV5Planes = 1;
	bmh.bV5BitCount = 32;
	bmh.bV5Compression = BI_BITFIELDS;
	
	bmh.bV5RedMask =   0x00FF0000;
	bmh.bV5GreenMask = 0x0000FF00;
	bmh.bV5BlueMask =  0x000000FF;
	bmh.bV5AlphaMask = 0xFF000000;


		for(byte i = 0; i < arrayMax; i++)
	if (filledArr[i] == false) { nextInstance = (int)i; break; } // find next free place



	hBitArr[nextInstance] = CreateDIBitmap(GetDC(NULL), (BITMAPINFOHEADER *) &bmh, CBM_INIT,
					image, (BITMAPINFO *) &bmh, DIB_RGB_COLORS);

	wholeWidthArr[nextInstance] = wholeWidth;
	SIZE siz = {(LONG)frameWidth, (LONG)frameHeight};
	sizeArr[nextInstance] = siz;
	filledArr[nextInstance] = true; // this part of the array is in use




	stbi_image_free(image);

	return (nextInstance);
	
}


//////// ATTENTION: THIS FUNCTION IS NOT WORKING!
DLLEXPORT double Duplicate(double sprite, double index) { 

	if (filledArr[(byte)sprite] != true) return(-1);


		for(byte i = 0; i < arrayMax; i++)
	if (!filledArr[i]) {nextInstance = (int)i; break;} // find next free place



	hBitArr[nextInstance] = hBitArr[(byte)sprite];


	wholeWidthArr[nextInstance] = wholeWidthArr[(byte)sprite];
	sizeArr[nextInstance] = sizeArr[(byte)sprite];
	filledArr[nextInstance] = true; // this part of the array is in use


	return (nextInstance);	
}
//////////////////////////////////////////////////



void drawingThread(void*);

DLLEXPORT double Start(double sprite, double xcor, double ycor, double waitTime, double fra, double alpha, double windowed) { 

	byte spr = (byte)sprite;

	POINT pos = {(LONG)xcor, (LONG)ycor};
	positionArr[spr] = pos;
	timeArr[spr] = (int)waitTime;
	alphaArr[spr] = (byte)(alpha*255);
	frameArr[spr] = (int)fra;
	runningArr[spr] = true;

	if (windowed == 1) windowedArr[spr] = true;
	else windowedArr[spr] = false;


	currentStartedSpr = (byte)sprite;

	_beginthread( drawingThread, 0, 0);


	Sleep(10);


	return(1);

	}


void drawingThread(void*) // this is the prozess which is called in the background in another Thread
{
	int localSpr = currentStartedSpr;
	
	int xx = 0, yy = 0;
	if (windowedArr[localSpr])
	{
		xx = windowX;
		yy = windowY;
	}

	HWND hWnd = CreateWindowEx(WS_EX_LAYERED |
    WS_EX_TRANSPARENT
	| WS_EX_NOACTIVATE
//    | WS_EX_TOPMOST
	, szWindowClass, 0, 
	WS_POPUP | WS_VISIBLE
	,positionArr[localSpr].x+xx,positionArr[localSpr].y+yy,
	sizeArr[localSpr].cx, sizeArr[localSpr].cy , 0  , NULL, NULL, NULL);



    HDC hdcScreen = GetDC(0);
    HDC hdc = CreateCompatibleDC(hdcScreen);
    ReleaseDC(0, hdcScreen);
    SelectObject(hdc, hBitArr[localSpr]);


    BLENDFUNCTION bf;
    bf.BlendOp = AC_SRC_OVER;
    bf.BlendFlags = 0;
    bf.SourceConstantAlpha = alphaArr[localSpr];
    bf.AlphaFormat = AC_SRC_ALPHA;

	if (GMvisible) ShowWindow(hWnd, SW_SHOWNA);
	else ShowWindow(hWnd, SW_HIDE);


	POINT offSet = {0,0};
	

	while(1)
	{

		if ((!runningArr[localSpr]) || killAll) break;

		if (timeArr[localSpr] > 0)
		{
		
		for(int t = 0; t < (timeArr[localSpr]/15); t += 1)
		{

		Sleep(15);

		if ((!runningArr[localSpr]) || killAll) break;


		if (blendAlphaArr[localSpr] >0)
			if ((abs(blendAlphaArr[localSpr]-alphaArr[localSpr])) <= abs(blendSubArr[localSpr]))
			{
				alphaArr[localSpr] = blendAlphaArr[localSpr]-1;
				blendAlphaArr[localSpr] = 0;
			}
			else alphaArr[localSpr] += blendSubArr[localSpr];

		
		if (updateArr[localSpr])
		{
			if (windowedArr[localSpr])
				MoveWindow(hWnd,windowX+positionArr[localSpr].x,windowY+positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
				else MoveWindow(hWnd,positionArr[localSpr].x,positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
		
		updateArr[localSpr] = false;
		}
		

		if (GMvisible)
		{ ShowWindow(hWnd, SW_SHOWNA);
		if (onfront)
		SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		else
		{
		SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		SetWindowPos(hWnd, GetForegroundWindow(), 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		}} else ShowWindow(hWnd, SW_HIDE);
	

		if (attachedArr[localSpr])
			MoveWindow(hWnd,mouseXY.x+positionArr[localSpr].x,mouseXY.y+positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
		}


		if (timeArr[localSpr] > 0)
		frameArr[localSpr] += 1;
		if (frameArr[localSpr]*sizeArr[localSpr].cx >= wholeWidthArr[localSpr]) frameArr[localSpr] = 0;

		}
		else
		{

		Sleep(15);

		if ((!runningArr[localSpr]) || killAll) break;
	

		if (blendAlphaArr[localSpr] >0)

			if ((abs(blendAlphaArr[localSpr]-alphaArr[localSpr])) <= abs(blendSubArr[localSpr]))
			{
				alphaArr[localSpr] = blendAlphaArr[localSpr]-1;
				blendAlphaArr[localSpr] = 0;
			}
			else alphaArr[localSpr] += blendSubArr[localSpr];



		if (updateArr[localSpr])
		{
			if (windowedArr[localSpr])
				MoveWindow(hWnd,windowX+positionArr[localSpr].x,windowY+positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
				else MoveWindow(hWnd,positionArr[localSpr].x,positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
		updateArr[localSpr] = false;
		}

		if (GMvisible)
		{ ShowWindow(hWnd, SW_SHOWNA);
		if (onfront)
		SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		else
		{
		SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		SetWindowPos(hWnd, GetForegroundWindow(), 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
		}} else ShowWindow(hWnd, SW_HIDE);
		
		
		if (attachedArr[localSpr])
			MoveWindow(hWnd,mouseXY.x+positionArr[localSpr].x,mouseXY.y+positionArr[localSpr].y,sizeArr[localSpr].cx,sizeArr[localSpr].cy,true);
		}


		if ((!runningArr[localSpr]) || killAll) break;

		offSet.x = frameArr[localSpr]*sizeArr[localSpr].cx;
		bf.SourceConstantAlpha = alphaArr[localSpr];


		UpdateLayeredWindow(hWnd, 0, NULL, &sizeArr[localSpr], hdc, &offSet, 0, &bf, ULW_ALPHA);


	}



    DeleteDC(hdc);
	delete hWnd;

	Sleep(10);

	_endthread();

}


DLLEXPORT double Attach(double sprite,double attached) { 

	attachedArr[(byte)sprite] = (bool)attached;
	return(1);

}


DLLEXPORT double Speed(double sprite, double sp) { 

	timeArr[(byte)sprite] = (int)sp;
	return 1;

}

DLLEXPORT double Frame(double sprite, double fr) { 

	frameArr[(byte)sprite] = (int)fr;
	return 1;

}

DLLEXPORT double GetFrame(double sprite) { 

	return(frameArr[(byte)sprite]);

}

DLLEXPORT double Alpha(double sprite, double al) { 

	alphaArr[(byte)sprite] = (byte)(al*255);
	return 1;

}

DLLEXPORT double FadeTo(double sprite, double targetAl, double mSeconds) { 

	if (targetAl < 0)
	if (blendAlphaArr[(byte)sprite] > 0)
		return(1);
	else
		return(0);
	else
	{
		blendAlphaArr[(byte)sprite] = max((byte)(targetAl*255),1);
		blendSubArr[(byte)sprite] = (int)(((targetAl*255)-alphaArr[(byte)sprite])/(mSeconds/15));
		updateArr[(byte)sprite] = 1;
		return(alphaArr[(byte)sprite]);
	}

}

DLLEXPORT double Posit(double sprite, double xcor, double ycor, double windowed) { 

	positionArr[(byte)sprite].x = (LONG)xcor;
	positionArr[(byte)sprite].y = (LONG)ycor;
	windowedArr[(byte)sprite] = (bool)windowed;
	updateArr[(byte)sprite] = 1;
	return 1;

}

DLLEXPORT double Pause(double sprite) { 

	if (timeArr[(byte)sprite] < 0) timeArr[(byte)sprite] += 10000;
	else timeArr[(byte)sprite] -= 10000;
	return 1;
}


DLLEXPORT double Stop(double sprite) { 

	runningArr[(byte)sprite] = false;
	updateArr[(byte)sprite] = false;
	return 1;

}

DLLEXPORT double Unload(double sprite) { 

	runningArr[(byte)sprite] = false;
	if (filledArr[(byte)sprite] = true)
	DeleteObject(hBitArr[(byte)sprite]);
	filledArr[(byte)sprite] = false;
	return 1;
}

    